<?php

/**
 *  Informatica Eindproject D4p
 *  6in3, Stedelijk Gymnasium Nijmegen
 *  Docent: Hans de Wolf
 *
 *  ==================
 *
 *  Daniel Boutros,
 *  Christiaan Goossens,
 *  Jelmer Hinssen
 */

namespace Inforbank\Application\Auth;

use Inforbank\Application;
use Inforbank\Application\Helper\Redirect;

class Middleware
{
    public function __invoke($request, $response, $next)
    {
        $container = Application::getContainer();
        $uri = $request->getUri();

        $path = $uri->getPath();

        if (substr($path, 0, 1) != '/') {
            $path = "/".$path;
        }

        $query = $uri->getQuery();

        // Check for an existing session
        if ($container->auth->isUserAuthenticated()) {
            return $next($request, $response);
        } else {
            // Redirect to the login page
            if ($query !== "") {
                return Redirect::create($request, $response, '/login?redirect='.$path."&".$query);
            } elseif ($path === "/") {
                return Redirect::create($request, $response, '/login');
            } else {
                return Redirect::create($request, $response, '/login?redirect='.$path);
            }
        }
    }
}
