<?php

/**
 *  Informatica Eindproject D4p
 *  6in3, Stedelijk Gymnasium Nijmegen
 *  Docent: Hans de Wolf
 *
 *  ==================
 *
 *  Daniel Boutros,
 *  Christiaan Goossens,
 *  Jelmer Hinssen
 */

namespace Inforbank\Application;

use Inforbank\Application\Auth\Middleware;
use Inforbank\Application\Helper\Header;
use Inforbank\Application\Helper\Statistieken as StatistiekenHelper;
use Slim\App;

class Statistieken
{
    public function __construct(App $app)
    {
        $app->get('/statistieken/{rekeningnummer}', function ($request, $response, $args) {
            try {
                $verloop = StatistiekenHelper::getSaldoverloop(30, $args['rekeningnummer']);
                return $this->renderer->render($response, "statistieken.phtml", [
                "header" => Header::getHeaderData(),
                "rekeningnr" => $args['rekeningnummer'],
                "statistieken" => [
                    "x-as" => $verloop['x-as'],
                    "y-as" => $verloop['y-as']
                ]
                ]);
            } catch (\Exception $e) {
                return $this->renderer->render($response, "statistieken.phtml", [
                "header" => Header::getHeaderData(),
                "rekeningnr" => $args['rekeningnummer'],
                "statistieken" => false
                ]);
            }
        })->add(new Middleware());
    }
}
